Index: waeup/trunk/src/waeup/browser/viewlets.py
===================================================================
--- waeup/trunk/src/waeup/browser/viewlets.py	(revision 4789)
+++ waeup/trunk/src/waeup/browser/viewlets.py	(revision 4789)
@@ -0,0 +1,447 @@
+# -*- coding: utf-8 -*-
+
+import grok
+
+from hurry import yui
+from zope.component import getMultiAdapter
+from zope.location.interfaces import ISite
+from waeup.browser.pages import (UniversityPage, FacultyContainerPage,
+                                 DatacenterPage, FacultyPage, DepartmentPage,
+                                 CoursePage, CertificatePage,
+                                 CertificateCoursePage)
+from waeup.browser.interfaces import IBreadcrumbContainer
+from waeup.interfaces import (IUniversity, IWAeUPObject, IWAeUPXMLExporter,
+                              IWAeUPXMLImporter, IFacultyContainer, IFaculty,
+                              IDepartment, ICourse, ICertificate,
+                              ICertificateCourse, IDataCenter)
+
+grok.templatedir('templates')
+grok.context(IWAeUPObject) # Make IWAeUPObject the default context
+
+class LeftSidebar(grok.ViewletManager):
+    grok.name('left')
+
+class BreadCrumbManager(grok.ViewletManager):
+    grok.name('breadcrumbs')
+
+class ActionBar(grok.ViewletManager):
+    grok.name('actionbar')
+    pass
+
+#
+# Baseclasses that give some defaults for really used viewlets.
+#
+class ActionButton(grok.Viewlet):
+    """A base for action buttons.
+
+    An action button provides an icon, some text and links to a
+    target.  If you want to set a different text, icon or target name
+    for some active button below, just override the approriate
+    attribute in the concerned viewlet.
+
+    Action buttons provide by default dynamic attributes
+
+     * ``alt``
+          An alternative text for the icon. By default the same as
+          the text.
+
+     * ``icon_url``
+          The URL of the icon.
+
+     * ``target_url``
+          The URL of the link target.
+
+    """
+    grok.baseclass()
+    grok.context(IWAeUPObject)
+    grok.template('actionbutton')
+    grok.viewletmanager(ActionBar)
+    icon = 'actionicon_modify.png' # File must exist in static/
+    target = '@@manage' # link to this viewname.
+    text = 'Edit settings' # Text to display on the button
+
+    @property
+    def alt(self):
+        """Alternative text for icon.
+        """
+        return self.text
+
+    @property
+    def icon_url(self):
+        """Get the icon URL.
+        """
+        return self.view.static[self.icon]()
+
+    @property
+    def target_url(self):
+        """Get a URL to the target...
+        """
+        return self.view.url(self.view.context, self.target)
+
+    
+class ManageActionButton(ActionButton):
+    """A base for 'edit' buttons
+    """
+    grok.baseclass()
+    grok.order(2)
+    grok.require('waeup.manageUniversity')
+    icon = 'actionicon_modify.png'
+    target = '@@manage'
+    text = 'Edit settings'
+
+class AddActionButton(ActionButton):
+    """A base for 'add' buttons.
+    """
+    grok.baseclass()
+    grok.order(4)
+    grok.require('waeup.manageUniversity')
+    icon = 'actionicon_addfavorite.png'
+    target = 'add'
+    text = 'Add'
+
+
+#
+# General viewlets (for more than one page/context)
+#
+
+class BreadCrumbs(grok.Viewlet):
+    grok.context(IWAeUPObject)
+    grok.viewletmanager(BreadCrumbManager)
+    grok.order(1)
+
+    def getEntries(self):
+        result = []
+        site = grok.getSite()
+        context = self.context
+        breadcrumbs = IBreadcrumbContainer(self.view)
+        for breadcrumb in breadcrumbs:
+            yield dict(
+                title = breadcrumb.title,
+                url = self.view.url(breadcrumb.context, breadcrumb.viewname)
+                )
+
+
+# Problem with circular references. Disabled for now...
+# class ExportXMLAction(grok.Viewlet):
+#    grok.viewletmanager(ActionBar)
+#     #grok.view(Index)
+#     grok.order(98)
+#     grok.require('waeup.manageUniversity')
+
+#class ImportXMLAction(grok.Viewlet):
+#    grok.viewletmanager(ActionBar)
+#    #grok.view(Index)
+#    grok.order(99)
+#    grok.require('waeup.manageUniversity')
+#
+#    def update(self):
+#        # We cannot simply replace local sites.
+#        self.can_import = not ISite.providedBy(self.context)
+
+class LeftSidebarLink(grok.Viewlet):
+    """ An entry on left sidebar.
+
+    This is only a baseclass that won't be rendered actually. Deriving
+    viewlets can override certain values and will be rendered with the
+    values set here as default.
+    """
+    grok.baseclass()
+    grok.viewletmanager(LeftSidebar)
+    grok.context(IWAeUPObject)
+    grok.order(5)
+    grok.require('waeup.manageUniversity')
+
+    title = 'Text of link'
+    @property
+    def url(self):
+        return 'URL to link to'
+    
+    def render(self):
+        return u'<div class="portlet"><a href="%s">%s</a></div>' % (
+            self.url, self.title)
+
+
+            
+#
+# waeup.app.University viewlets...
+#
+class Login(grok.Viewlet):
+    """This viewlet allows to login in the sidebar.
+    """
+    grok.viewletmanager(LeftSidebar)
+    grok.context(IUniversity)
+    grok.view(UniversityPage)
+    grok.order(2)
+
+    def isAuthenticated(self):
+        """Is the calling user authenticated?
+        """
+        return self.request.principal.id != 'zope.anybody'
+
+class ManageLink(grok.Viewlet):
+    grok.viewletmanager(LeftSidebar)
+    grok.context(IUniversity)
+    grok.view(UniversityPage)
+    grok.order(5)
+    # This link is only displayed, if the user is
+    # allowed to use it!
+    grok.require('waeup.manageUniversity')
+    
+    def render(self):
+        return u'<div class="portlet"><a href="manage">Settings</a></div>'
+
+class ManageFacultiesLink(grok.Viewlet):
+    grok.viewletmanager(LeftSidebar)
+    grok.context(IUniversity)
+    grok.view(UniversityPage)
+    grok.order(6)
+    # This is so cool! This link is only displayed, when the user is
+    # allowed to use it!
+    grok.require('waeup.manageUniversity')
+    
+    def render(self):
+        return u'<div class="portlet"><a href="faculties">Manage faculties</a></div>'
+
+class ManageUsersLink(grok.Viewlet):
+    grok.viewletmanager(LeftSidebar)
+    grok.context(IUniversity)
+    grok.view(UniversityPage)
+    grok.order(6)
+    grok.require('waeup.manageUsers')
+
+    def render(self):
+        return u'<div class="portlet"><a href="users">Manage users</a></div>'
+
+class ManageDataCenter(grok.Viewlet):
+    grok.viewletmanager(LeftSidebar)
+    grok.context(IUniversity)
+    grok.view(UniversityPage)
+    grok.order(6)
+    grok.require('waeup.manageUniversity')
+
+    def render(self):
+        return u'<div class="portlet"><a href="datacenter">Data Center</a></div>'
+
+#
+# Manage ("Edit settings") actions...
+#
+class ManageUniversityActionButton(ManageActionButton):
+    """ 'Edit settings' button for University instances.
+    """
+    grok.context(IUniversity)
+    grok.view(UniversityPage)
+    
+class ManageFacultiesActionButton(ManageActionButton):
+    """ 'Edit settings' button for faculty container.
+    """
+    grok.context(IFacultyContainer)
+    grok.view(FacultyContainerPage)
+
+class ManageDataCenterActionButton(ManageActionButton):
+    """ 'Edit settings' button for datacenter.
+    """
+    grok.context(IDataCenter)
+    grok.view(DatacenterPage)
+    
+class ManageFacultyActionButton(ManageActionButton):
+    """ 'Edit settings' button for faculties.
+    """
+    grok.context(IFaculty)
+    grok.view(FacultyPage)
+
+class ManageDepartmentActionButton(ManageActionButton):
+    """ 'Edit settings' button for departments.
+    """
+    grok.context(IDepartment)
+    grok.view(DepartmentPage)
+
+class ManageCourseActionButton(ManageActionButton):
+    """ 'Edit settings' button for courses.
+    """
+    grok.context(ICourse)
+    grok.view(CoursePage)
+    
+class ManageCertificateActionButton(ManageActionButton):
+    """ 'Edit settings' button for certificates.
+    """
+    grok.context(ICertificate)
+    grok.view(CertificatePage)
+
+class ManageCertificateCourseActionButton(ManageActionButton):
+    """ 'Edit settings' button for certificate courses.
+    """
+    grok.context(ICertificateCourse)
+    grok.view(CertificateCoursePage)
+
+#
+# Add actions...
+#
+class AddAction(grok.Viewlet):
+    """Base class for 'adding actions'.
+
+    AddActions are viewlets that render a button linked to an adding
+    page. To create such a button in one of your pages, follow the
+    following steps:
+
+    - Create a new class derived from AddAction. In this class:
+    
+    - Set a grok.context() for the context type of your page. So, if
+      your page sets grok.context(IMyFunnyType), do the same in the
+      viewlet class.
+
+    - Set the Page on which the button should appear using
+      grok.view(). So, if your page class is MyFunnyPage, do
+      grok.view(MyFunnyPage).
+
+    - Set the template to use to 'addaction'. This means to use the
+      'addaction.pt' template in the templates/ dir. Don't fiddle
+      around with this template file, as it is used also by other
+      viewlets.
+
+    - If you want only certain authorized users to see the button, use
+      grok.require(<Permission>). By default only people with
+      waeup.manageUniversity permission are able to see your new
+      button. Other users, however, will still see your page, only
+      without the button rendered.
+
+    - As one can define several buttons for a certain page, you can
+      influence the order of buttons by setting grok.order(<num>). The
+      lower the number, the more left the button will be displayed and
+      vice versa. Default is 4.
+      
+    - Set the page name as ``addview_name`` attribute. This means, if
+      the page, the button is linked to can be reached by calling
+      http://localhost:8080/<current_location>/@@addfoo, then you should set::
+
+        addview_name = 'addfoo'
+
+      By default the target page name 'add' is assumed. You should
+      have good reasons not to name your AddFormPage 'add'.
+
+    - Set the button text by setting the ``addlink_text``
+      attribute. If you set it to 'Add foobar', then on the page will
+      appear a button with a small 'add stuff' icon and the text 'Add
+      foobar'.
+    """
+    grok.viewletmanager(ActionBar)
+    grok.view(FacultyContainerPage)
+    grok.context(IFacultyContainer)
+    grok.order(4)
+    grok.template('addaction')
+    grok.require('waeup.manageUniversity')
+    grok.baseclass()
+
+    addview_name = 'add'
+    addlink_text = 'Add department'
+
+    def getTargetURL(self):
+        return '%s/@@%s' % (self.view.url(self.view.context), self.addview_name)
+
+class AddFacultyActionButton(AddActionButton):
+    grok.context(IFacultyContainer)
+    grok.view(FacultyContainerPage)
+    text = 'Add faculty'
+    
+class AddDepartmentActionButton(AddActionButton):
+    grok.context(IFaculty)
+    grok.view(FacultyPage)
+    text = 'Add department'
+
+class AddCertificateActionButton(AddActionButton):
+    grok.context(IDepartment)
+    grok.view(DepartmentPage)
+    grok.order(3)
+    text = 'Add certificate'
+    target = 'addcertificate'
+    
+class AddCourseActionButton(AddActionButton):
+    grok.context(IDepartment)
+    grok.view(DepartmentPage)
+    grok.order(4)
+    text = 'Add course'
+    target = 'addcourse'
+
+class AddCertificateActionButton(AddActionButton):
+    grok.context(ICertificate)
+    grok.view(CertificatePage)
+    grok.order(4)
+    text = 'Add course reference'
+    target = 'addcertificatecourse'
+
+
+#
+# Primary navigation tabs (in upper left navigation bar)...
+#
+class PrimaryNavManager(grok.ViewletManager):
+    """Viewlet manager for the primary navigation tab.
+    """
+    grok.name('primary_nav')
+
+class PrimaryNavTab(grok.Viewlet):
+    """Base for primary nav tabs.
+    """
+    grok.baseclass()
+    grok.viewletmanager(PrimaryNavManager)
+    grok.order(1)
+    grok.require('waeup.manageUniversity')
+
+    pnav = 0 # This is a kind of id of a tab. If some page provides
+             # also a 'pnav' attribute with the same value (here: 0),
+             # then the tab will be rendered as 'active' when the page
+             # gets rendered.
+             #
+             # This way you can assign certain pages to certain
+             # primary nav tabs. Each primary tab should therefore set
+             # the 'pnav' attribute to a different value (or several
+             # tabs might be rendered as active simultanously when the
+             # page gets rendered.
+    tab_title = u'Some Text'
+    
+    @property
+    def link_target(self):
+        return self.view.application_url()
+
+    @property
+    def active(self):
+        view_pnav = getattr(self.view, 'pnav', 0)
+        if view_pnav == self.pnav:
+            return 'active'
+        return ''
+
+class HomeTab(PrimaryNavTab):
+    """Home-tab in primary navigation.
+    """
+    grok.order(1)
+    grok.require('waeup.Public')
+    grok.template('primarynavtab')
+
+    pnav = 0
+    tab_title = u'Home'
+
+class FacultiesTab(PrimaryNavTab):
+    """Faculties-tab in primary navigation.
+    """
+    grok.order(2)
+    grok.require('waeup.manageUniversity')
+    grok.template('primarynavtab')
+
+    pnav = 1
+    tab_title = u'Faculties'
+
+    @property
+    def link_target(self):
+        return self.view.application_url('faculties')
+
+class SearchTab(PrimaryNavTab):
+    """Search tab in primary navigation.
+    """
+    grok.order(3)
+    grok.require('waeup.manageUniversity')
+    grok.template('primarynavtab')
+
+    pnav = 2
+    tab_title = u'Search'
+
+    @property
+    def link_target(self):
+        return self.view.application_url('@@search')
Index: waeup/trunk/src/waeup/catalog.py
===================================================================
--- waeup/trunk/src/waeup/catalog.py	(revision 3551)
+++ waeup/trunk/src/waeup/catalog.py	(revision 4789)
@@ -1,6 +1,2 @@
-import sys
-import csv
-import random
-from datetime import datetime
 import os
 import grok
@@ -8,7 +4,12 @@
 from hurry.query.query import Query, Text
 from hurry.query import Eq
-from app import University
-from students.interfaces import IStudent
-from students.student import Student
+from waeup.app import University
+from waeup.interfaces import ICourse, ICertificateCourse
+from waeup.student.interfaces import IStudent
+from zope.app.catalog.interfaces import ICatalog
+from zope.app.intid.interfaces import IIntIds
+from zope.component import getUtility
+from zope.component.interfaces import ComponentLookupError
+
 
 class StudentIndexes(grok.Indexes):
@@ -20,17 +21,96 @@
 
 
-class StudentSearch(grok.View):
-    grok.context(University)
+class CourseIndexes(grok.Indexes):
+     grok.site(University)
+     grok.name('courses_catalog')
+     grok.context(ICourse)
 
-    def update(self, query=None):
-        self.search_result = []
-        if query is not None:
-            self.search_result = self.search_context(query)
-            print "RESULT: ", list(self.search_result)
+     code = index.Field(attribute='code')
+     title = index.Text(attribute='title')
 
-    def search_context(self, query):
-        result = Query().searchResults(
-            Eq(('students_catalog', 'name'), query)
-            )
-        return result
-    
+class CourseCertificatesIndexes(grok.Indexes):
+     grok.site(University)
+     grok.name('certcourses_catalog')
+     grok.context(ICertificateCourse)
+
+     course_code = index.Field(attribute='getCourseCode')
+
+@grok.subscribe(ICourse, grok.IObjectAddedEvent)
+def handleCourseAdd(obj, event):
+     """Index an added course with the local catalog.
+
+     Courses are not indexed automatically, as they are not a
+     dictionary subitem of the accompanied site object
+     (`IUniversity`). I.e. one cannot get them by asking for
+     ``app['FACCODE']['DEPTCODE']['COURSECODE']`` but one has to ask for
+     ``app.faculties['FACCODE']['DEPTCODE'].courses['COURSECODE']``.
+
+     Once, a course is indexed we can leave the further handling to
+     the default component architechture. At least removals will
+     be handled correctly then (and the course unindexed).
+     """
+     try:
+          cat = getUtility(ICatalog, name='courses_catalog')
+     except ComponentLookupError:
+          # catalog not available. This might happen during tests.
+          return
+     intids = getUtility(IIntIds)
+     index = cat['code']
+     index.index_doc(intids.getId(obj), obj)
+
+from zope.interface import Interface
+from zope import schema
+
+class IQueryResultItem(Interface):
+     url = schema.TextLine(
+          title = u'URL that links to the found item')
+     title = schema.TextLine(
+          title = u'Title displayed in search results.')
+     description = schema.Text(
+          title = u'Longer description of the item found.')
+     
+     
+class QueryResultItem(object):
+     grok.implements(IQueryResultItem)
+     url = None
+     title = None
+     description = None
+     
+     def __init__(self, context, view):
+          self.context = context
+          self.url = view.url(context)
+          self.title = context.title
+          self.description = ''
+     
+class CourseQueryResultItem(QueryResultItem):
+     def __init__(self, context, view):
+          self.context = context
+          self.url = view.url(context)
+          self.title = "COURSE: " + context.title
+          self.description = 'code: %s' % context.code
+
+def search(query=None, view=None):
+     if not query:
+          return []
+     cat = getUtility(ICatalog, name='courses_catalog')
+     results = list(cat.searchResults(code=(query, query)))
+          
+     hitlist = []
+     results = Query().searchResults(
+          Eq(('courses_catalog', 'code'), query))
+     for result in results:
+          hitlist.append(CourseQueryResultItem(result, view=view))
+
+     results = Query().searchResults(
+          Text(('courses_catalog', 'title'), query))
+          
+     for result in results:
+          hitlist.append(CourseQueryResultItem(result, view=view))
+
+     return hitlist
+
+def search_context(query):
+     result = Query().searchResults(
+          Eq(('students_catalog', 'name'), query)
+          )
+     return result
Index: waeup/trunk/src/waeup/csvfile/__init__.py
===================================================================
--- waeup/trunk/src/waeup/csvfile/__init__.py	(revision 4789)
+++ waeup/trunk/src/waeup/csvfile/__init__.py	(revision 4789)
@@ -0,0 +1,3 @@
+# Make this a package.
+from waeup.csvfile.csvfile import getCSVFile, CSVFile
+from waeup.csvfile.util import toBool
Index: waeup/trunk/src/waeup/csvfile/csvfile.py
===================================================================
--- waeup/trunk/src/waeup/csvfile/csvfile.py	(revision 4789)
+++ waeup/trunk/src/waeup/csvfile/csvfile.py	(revision 4789)
@@ -0,0 +1,87 @@
+"""Support for CSV files.
+
+See README.txt and interfaces.py to learn more.
+"""
+
+import csv
+import grok
+from waeup.csvfile.interfaces import ICSVFile
+
+class CSVFile(grok.Adapter):
+    """A CSV file abstraction.
+    """
+    grok.context(basestring)
+    grok.implements(ICSVFile)
+
+    required_fields = []
+    path = None
+    
+    def __init__(self, context):
+        self.path = context
+        self.checkFields()
+
+    def checkFields(self):
+        headers = self.getHeaderFields()
+        missing = [x for x in self.required_fields
+                   if x not in headers]
+        if len(missing):
+            raise TypeError('Missing columns in CSV file: %s' % missing)
+        return
+            
+    def getDictReader(self):
+        return csv.DictReader(open(self.path, 'rb'))
+    
+    def getData(self):
+        reader = self.getDictReader()
+        for row in reader:
+            row = self.processRow(row)
+            yield row
+
+    def processRow(self, row):
+        return row
+
+    def getHeaderFields(self):
+        path = self.path
+        reader = self.getDictReader()
+        reader.next()
+        fields = reader.fieldnames
+        return sorted(reader.fieldnames)
+
+    
+# The registry for CSV file wrappers...
+csvwrappers = [CSVFile,]
+
+def getScore(path, wrapperclass):
+    """Compute a score for a certain wrapper related to a certain CSV
+    file.
+    """
+    wrapper = None
+    try:
+        wrapper = wrapperclass(path)
+    except:
+        return -1
+    required = wrapper.required_fields
+    if required == []:
+        return 0
+    available_headers = wrapper.getHeaderFields()
+    score = len([x for x in required if x in available_headers])
+    if score < len(required):
+        return -1
+    return score
+    
+    
+def getCSVFile(path):
+    """Get a CSVFile instance for a path.
+    """
+    best_score = -1
+    best_wrapper = None
+    
+    for wrapperclass in csvwrappers:
+        score = getScore(path, wrapperclass)
+        if score < best_score or score == -1:
+            continue
+        best_score, best_wrapper = score, wrapperclass
+    if best_wrapper is not None:
+        return best_wrapper(path)
+    return None
+
Index: waeup/trunk/src/waeup/csvfile/interfaces.py
===================================================================
--- waeup/trunk/src/waeup/csvfile/interfaces.py	(revision 4789)
+++ waeup/trunk/src/waeup/csvfile/interfaces.py	(revision 4789)
@@ -0,0 +1,37 @@
+"""Interfaces for waeup.csvfile.
+"""
+from zope.interface import Interface
+from zope import schema
+
+class ICSVFile(Interface):
+    """A wrapper for a CSV file.
+    """
+    required_fields = schema.List(
+        title = u'Required header fields.',
+        value_type = schema.TextLine(
+            title = u'Field name',
+            )
+        )
+    
+    path = schema.TextLine(
+        title = u'Filesystem path to wrapped file.'
+        )
+
+    def getData():
+        """Get a dict of data contained in the CSV file.
+        """
+        
+    def getHeaderFields():
+        """Get a list of (supported) header fields.
+        """
+    
+class ICSVDataReceiver(Interface):
+    """A receiver for CSV data.
+    """
+    def setData(data):
+        """Set data.
+        """
+
+class ICSVDataConnector(Interface):
+    """A connector brings together a CSVDataSource and a CSVDataReceiver.
+    """
Index: waeup/trunk/src/waeup/csvfile/meta.py
===================================================================
--- waeup/trunk/src/waeup/csvfile/meta.py	(revision 4789)
+++ waeup/trunk/src/waeup/csvfile/meta.py	(revision 4789)
@@ -0,0 +1,13 @@
+"""Meta configuration for waeup.csvfile components.
+"""
+import martian
+import waeup.csvfile.csvfile
+from waeup.csvfile import CSVFile
+
+# This grokker fills the registry on startup, with any class that is
+# derived from `CSVFileWrapper`...
+class CSVFileWrapperGrokker(martian.ClassGrokker):
+    martian.component(CSVFile)
+    def execute(self, klass, **kw):
+        waeup.csvfile.csvfile.csvwrappers.append(klass)
+        return True
Index: waeup/trunk/src/waeup/csvfile/util.py
===================================================================
--- waeup/trunk/src/waeup/csvfile/util.py	(revision 4789)
+++ waeup/trunk/src/waeup/csvfile/util.py	(revision 4789)
@@ -0,0 +1,12 @@
+"""Helpers for CSV import/export.
+"""
+
+## type casts
+
+def toBool(string):
+    if not isinstance(string, basestring):
+        return string
+    string = string.lower()
+    if string in ['true', 'yes', 'y', 'on', 'checked']:
+        return True
+    return False
Index: waeup/trunk/src/waeup/datacenter.py
===================================================================
--- waeup/trunk/src/waeup/datacenter.py	(revision 4789)
+++ waeup/trunk/src/waeup/datacenter.py	(revision 4789)
@@ -0,0 +1,219 @@
+"""WAeUP data center.
+
+The waeup data center cares for management of upload data and provides
+tools for importing/exporting CSV data.
+"""
+import os
+import struct
+import grok
+from datetime import datetime
+from zope.component import getMultiAdapter
+from waeup.csvfile import getCSVFile
+from waeup.interfaces import (IDataCenter, IWAeUPCSVImporter,
+                              ICSVDataReceivers, IDataCenterFile)
+from waeup.utils.helpers import copyFileSystemTree
+
+class DataCenter(grok.Container):
+    """A data center contains CSV files.
+    """
+    grok.implements(IDataCenter)
+    storage = os.path.join(os.path.dirname(__file__), 'files')
+
+    def getReceivers(self):
+        receivers = []
+        curr_obj = getattr(self, '__parent__', None)
+        while curr_obj is not None:
+            if ICSVDataReceivers.providedBy(curr_obj):
+                receivers = self.getCSVDataReceivers(curr_obj)
+                break
+            curr_obj = getattr(curr_obj, '__parent__', None)
+        return receivers
+
+    def getReceiverIds(self):
+        """Get a dict of available receivers.
+
+        The keys of the result are the receiver ids.
+        """
+        receivers = self.getReceivers()
+        return dict([(self.getReceiverId(x), x) for x in receivers])
+    
+    def getImporters(self):
+        """Get a list of all importers available.
+
+        The search for available importers is done in two steps:
+
+        1) Look for a utility providing ICSVDataReceiver,
+
+        2) For every item of that utility: try to get an adapter
+           providing IWAeUPCSVImporter.
+        """
+        result = []
+        receivers = self.getReceivers()
+        files = self.getFiles()
+        for receiver in receivers:
+            for file in files:
+                wrapped_file = getCSVFile(file.context)
+                try:
+                    importer = getMultiAdapter((wrapped_file, receiver),
+                                           IWAeUPCSVImporter)
+                    result.append(importer)
+                except:
+                    # No multi-adapter for this combination available...
+                    pass
+        return result
+    
+    def getFiles(self):
+        """Get a list of files stored in `storage`.
+
+        Files are sorted by basename.
+        """
+        result = []
+        if not os.path.exists(self.storage):
+            return result
+        for filename in sorted(os.listdir(self.storage)):
+            fullpath = os.path.join(self.storage, filename)
+            if not os.path.isfile(fullpath):
+                continue
+            result.append(DataCenterFile(fullpath))
+        return result
+
+    def setStoragePath(self, path, move=False, overwrite=False):
+        """Set the path where to store files.
+        """
+        path = os.path.abspath(path)
+        not_copied = []
+        if not os.path.exists(path):
+            raise ValueError('The path given does not exist: %s' % path)
+        if move is True:
+
+            not_copied = copyFileSystemTree(self.storage, path,
+                                            overwrite=overwrite)
+        
+        self.storage = path
+        return not_copied
+
+    def getCSVDataReceivers(self, obj):
+        """Get a list of attributes, that can receive CSV data.
+
+        We also get a list of values, if obj is a container that
+        contains value items.
+        """
+        result = []
+        for attr_name in dir(obj):
+            if attr_name.startswith('_'):
+                continue
+            try:
+                attr = getattr(obj, attr_name)
+                # This might fail...
+                #IWAeUPCSVImporter(attr)
+                result.append(attr)
+            except:
+                pass
+        if hasattr(obj, 'values'):
+            try:
+                result.extend(obj.values())
+            except:
+                pass
+        return result
+
+    def getPossibleImports(self):
+        """Get list of possible imports.
+
+        A single import is defined as a tuple
+        
+          ( <file-descr>, <importers> )
+        
+        where ``<file-descr>`` is an `IDataCenterFile` object and
+        ``<importers>`` is a list of `IWAeUPCSVImporter` objects.
+        """
+        result = []
+        importers = self.getImporters()
+        for filedescr in self.getFiles():
+            possible_importers = []
+            for importer in importers:
+                if importer.csvfile.path != filedescr.context:
+                    continue
+                importer_context = (
+                    importer, self.getReceiverId(importer.receiver))
+                possible_importers.append(importer_context)
+            if len(possible_importers) == 0:
+                continue
+            result.append((filedescr, possible_importers))
+        return result
+
+    def getReceiverId(self, obj):
+        """Get a unique id for an object.
+
+        If the object is stored in ZODB it should contain a `_p_oid`
+        attribute, which is guaranteed to be unique over the ZODB.
+
+        If the object has no such attribute, then it will be held in
+        memory only and will vanish as soon as the request is over. In
+        this case we can use the memory address of it.
+
+        Both, the id() result and the ZODB oid, are actually integers
+        which we return as strings. To make the difference chrystal
+        clear, we prepend ``z`` to ids taken from ZODB oids.
+        """
+        if not hasattr(obj, '_p_oid'):
+            return str(id(obj))
+        oid = getattr(obj, '_p_oid')
+        if oid is None:
+            # The persistent object is not stored in the ZODB
+            return str(id(obj))
+        return 'z%s' % struct.unpack('>Q', oid)[0]
+
+    def doImport(self, path, receiverid, clear=None):
+        receivers = self.getReceiverIds()
+        if receiverid not in receivers.keys():
+            raise ValueError('The requested data receiver cannot be found.')
+        receiver = receivers[receiverid]
+        filewrapper = getCSVFile(path)
+        if filewrapper is None:
+            raise ValueError('Format of CSV file not supported.')
+        importer = getMultiAdapter((filewrapper, receiver), IWAeUPCSVImporter)
+        if clear is not None:
+            importer.doImport(clear_old_data=clear)
+        else:
+            importer.doImport()
+        return
+
+class DataCenterFile(object):
+    """A description of a file stored in data center.
+    """
+    grok.implements(IDataCenterFile)
+    
+    def __init__(self, context):
+        self.context = context
+        self.name = os.path.basename(self.context)
+        self.size = self.getSize()
+        self.uploaddate = self.getDate()
+
+    def getDate(self):
+        """Get a human readable datetime representation.
+        """
+        date = datetime.fromtimestamp(os.path.getctime(self.context))
+        return date.strftime('%c')
+
+    def getSize(self):
+        """Get a human readable file size.
+        """
+        bytesize = os.path.getsize(self.context)
+        size = "%s bytes" % bytesize
+        units = ['kb', 'MB', 'GB']
+        for power, unit in reversed(list(enumerate(units))):
+            power += 1
+            if bytesize >= 1024 ** power:
+                size = "%.2f %s" % (bytesize/(1024.0**power), unit)
+                break
+        return size
+
+class Import(object):
+    """Helper class to aggregate imports and their data.
+    """
+    def __init__(self, filedescr, importers):
+        self.file = filedescr
+        self.importers = []
+        for importer, receiverid in importers:
+            importer.receiverid = receiverid
+            self.importers.append(importer)
